VERSION 4.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   8070
   ClientLeft      =   1050
   ClientTop       =   1755
   ClientWidth     =   9225
   Height          =   8760
   Left            =   990
   LinkTopic       =   "Form1"
   ScaleHeight     =   8070
   ScaleWidth      =   9225
   Top             =   1125
   Width           =   9345
   Begin VB.CommandButton cmdSpeed 
      Caption         =   "Speed"
      Height          =   495
      Left            =   3840
      TabIndex        =   10
      Top             =   5880
      Width           =   1215
   End
   Begin VB.CommandButton Command3 
      Caption         =   "&Stored Proc in/out"
      Height          =   495
      Left            =   6360
      TabIndex        =   7
      Top             =   7080
      Width           =   1215
   End
   Begin VB.CommandButton Command2 
      Caption         =   "&Result Set"
      Height          =   495
      Left            =   3600
      TabIndex        =   2
      Top             =   7080
      Width           =   1215
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Dyn Select"
      Height          =   495
      Left            =   1320
      TabIndex        =   1
      Top             =   7080
      Width           =   1215
   End
   Begin VB.Label lblParm4 
      Height          =   495
      Left            =   7560
      TabIndex        =   9
      Top             =   6240
      Width           =   1215
   End
   Begin VB.Label lblParm3 
      Height          =   495
      Left            =   7560
      TabIndex        =   8
      Top             =   5640
      Width           =   1215
   End
   Begin VB.Label Label4 
      Caption         =   "OUTPUT"
      Height          =   495
      Left            =   7560
      TabIndex        =   6
      Top             =   4920
      Width           =   1215
   End
   Begin VB.Label Label3 
      Caption         =   "INPUT:"
      Height          =   495
      Left            =   6120
      TabIndex        =   5
      Top             =   4920
      Width           =   1215
   End
   Begin VB.Label lblParm2 
      Height          =   495
      Left            =   6120
      TabIndex        =   4
      Top             =   6240
      Width           =   1215
   End
   Begin VB.Label lblParm1 
      Height          =   495
      Left            =   6120
      TabIndex        =   3
      Top             =   5520
      Width           =   1215
   End
   Begin MSRDC.MSRDC MSRDC1 
      Height          =   495
      Left            =   1920
      Top             =   5040
      Width           =   1215
      _Version        =   65536
      _ExtentX        =   2143
      _ExtentY        =   873
      _StockProps     =   4
      DataSourceName  =   ""
      RecordSource    =   ""
      LoginTimeout    =   15
      Connect         =   ""
      QueryTimeout    =   15
      RowsetSize      =   100
      RecordsetType   =   1
      MaxRows         =   -1
      LogMessages     =   ""
      KeysetSize      =   0
      ReadOnly        =   0   'False
      Options         =   0
      UserName        =   ""
      Password        =   ""
      CursorDriver    =   0
      EOFAction       =   0
      BOFAction       =   0
      ErrorThreshold  =   -1
      Caption         =   "MSRDC1"
      BackColor       =   16777215
      ForeColor       =   0
      Prompt          =   3
      LockType        =   3
      Appearance      =   1
   End
   Begin MSDBGrid.DBGrid DBGrid1 
      Bindings        =   "RDOCtl.frx":0000
      Height          =   4335
      Left            =   720
      OleObjectBlob   =   "RDOCtl.frx":000F
      TabIndex        =   0
      Top             =   240
      Width           =   7335
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuNOOP 
         Caption         =   "-"
      End
      Begin VB.Menu mnuExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuTests 
      Caption         =   "&Tests"
      Begin VB.Menu mnuSPRS 
         Caption         =   "Stored Procedure with result set"
      End
      Begin VB.Menu mnuSPRS2 
         Caption         =   "Stored Proc w/ &2 result sets"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuNull 
         Caption         =   "-"
      End
      Begin VB.Menu mnuAbout 
         Caption         =   "&About"
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

Private Sub SetRS(newrs As rdoResultset, sp As rdoPreparedStatement)
    Dim S As String
    On Error GoTo SetRSError
    S = newrs.Name
    'if it didn't trap then refresh the existing rs
    newrs.MoreResults
    newrs.Requery
    Exit Sub
SetRSError:
    'MsgBox "error " & Str(Err.Number)
    If Err.Number = 91 Then
        Set newrs = sp.OpenResultset(rdOpenForwardOnly)
    End If
End Sub



Private Sub cmdSpeed_Click()
    Dim rdoEnv As rdoEnvironment
    Dim rdoConn As rdoConnection
    Dim rdoPS As rdoPreparedStatement
    Dim rdoRS As rdoResultset
    Dim i
    Dim j As Integer
    Dim S As String
    Dim b As Boolean
    
    Dim sSQL As String
        
    lblParm1 = "in1"
    lblParm2 = "in2"
    sSQL = "Select * from DDILLING.CUSTCDT where CUSNUM > ? AND CUSNUM < ?"
    
    i = rdoEngine.rdoDefaultCursorDriver
    rdoEngine.rdoDefaultCursorDriver = 2
    
    Set rdoEnv = rdoCreateEnvironment("AS400Env", "", "")
    i = rdoEnv.CursorDriver
    
    Set rdoConn = rdoEnv.OpenConnection("RCHASDCN")
    S = rdoConn.Version             'ODBC driver version
    b = rdoConn.Updatable          'TRUE/FALSE
    
    Set rdoPS = rdoConn.CreatePreparedStatement("GetInfo", sSQL)
    i = rdoErrors.Count
    If i > 0 Then
        S = rdoErrors(0).Description
    End If
    rdoPS.LockType = rdConcurReadOnly
    i = rdoPS.RowsetSize
    'i = rdoPS.rdoParameters(0).Type    'check the parameter type
    
    rdoPS.rdoParameters(0).Direction = rdParamInput
    rdoPS.rdoParameters(1).Direction = rdParamInput
    
    rdoPS.rdoParameters(0) = 1
    rdoPS.rdoParameters(1) = 500
    
    
    Set rdoRS = rdoPS.OpenResultset(rdOpenForwardOnly)
    i = rdoErrors.Count
    If i > 0 Then
        S = rdoErrors(0).Description
    End If

    i = rdoRS.rdoColumns.Count
    S = rdoRS.rdoColumns(0).Name
    j = 0
    Do While Not rdoRS.EOF
        j = j + 1
        i = rdoRS.rdoColumns(0).Value
        rdoRS.MoveNext
    Loop
     S = Str(j) & " rows fetched.  Last Value = " & Str(i)
    MsgBox S
    rdoRS.MoreResults
    i = rdoErrors.Count
    If i > 0 Then
        S = rdoErrors(0).Description
    End If
   
    i = rdoPS.Type    'rdQSelect   0  Select
                     'rdQAction   1  Action
                     'rdQProcedure   2  Procedural
    
    
    
    rdoConn.Close             'Close the ODBC connection
    rdoEnv.Close              'Can't close the default Env

End Sub

Private Sub Command1_Click()
    'works and is updatable:
    '   LockType 3: optimistic
    '   cursor driver 1: ODBC
    '   Readonly False
    '   Resultsettype 1: Keyset driven
    'Read only and fast:
    '   LockType 1:  ReadOnly
    '   cursor driver 1: ODBC
    '   Readonly True/False
    '   Resultsettype 3: Static
    
    '               Cur Lib   Lock Type   ReadOnly    Resultset
    '  Updateable    1yes         3         FALSE      1-key        via cursor library
    '  Updateable    1yes         4         FALSE      1-key        via cursor library
    '                1yes         2         FALSE      1-key        'cursor lib not capable
    '  Read Only     1yes         1         TRUE       3-static     'worked as read only
    '                1yes         2         FALSE      3-static     'Can't load
    '  FAILED        0asneeded    3         FALSE      1-key        Driver not capable
    '  FAILED        0            4         FALSE      1-key        Driver not capable
    '  FAILED        0            2         FALSE      1-key        'cursor not open if update
    '                0            1         TRUE       3-static     'worked as read only
    '                0            2         FALSE      3-static     'Cursor not open
    '                0            1         false      3-static     'Read oNly
    '                2host        2         FALSE      1&3        'Invalid cursor state
        
    MSRDC1.DataSourceName = "RCHASLQL"
    MSRDC1.CursorDriver = 2   'ODBC Cursor  (2 Server should work?)
    
    'Lock type and readonly
    MSRDC1.LockType = 2      'Concur lock for pessimistic  (1, 2, or 4?)
    MSRDC1.ReadOnly = False
    
    
    'MSRDC1.ResultsetType = 1     'Keyset driven must be used with AS/400
    MSRDC1.ResultsetType = 3  'static requires cursor library?
    MSRDC1.SQL = "Select * from custcdt"
    MSRDC1.Refresh
End Sub


Private Sub Command2_Click()
   Dim b As Boolean
   Dim S As String
   Dim i As Integer
    
    'worked with defaults
    MSRDC1.DataSourceName = "RCHASDCN"
    MSRDC1.CursorDriver = 1   'ODBC Cursor
    
    'tried to change default
    'MSRDC1.ResultsetType = 3  'static and key 1 both worked
    'MSRDC1.ReadOnly = True  Can't use this!
    MSRDC1.SQL = "{ Call CRSDAVE('xzy') }"
    MSRDC1.Refresh
   
   b = MSRDC1.ReadOnly
      
End Sub


Private Sub Command3_Click()
    Dim rdoEnv As rdoEnvironment
    Dim rdoConn As rdoConnection
    Dim rdoPS As rdoPreparedStatement
    Dim i As Integer
    Dim S As String
    Dim b As Boolean
    Dim Temp
    
    Dim sSQL As String
        
    lblParm1 = "in1"
    lblParm2 = "in2"
    'sSQL = "{ Call DDILLING.DAVEE( ?, ?, ?, ?) }"   '2 input 2 output
    sSQL = "{ Call DDILLING.DAVEE2( ?, ?, ?, ?) }"   '2 input 2 output
    
    'create procedure DDILLING.DAVEE  (IN CHAR(8), IN CHAR(8), OUT CHAR(10), OUT CHAR(7))  EXTERNAL NAME DDILLING.DAVEE LANGUAGE C GENERAL
    
   rdoEngine.rdoDefaultCursorDriver = 2   'SQL_CUR_USE_DRIVER host side cursor
   Set rdoEnv = rdoCreateEnvironment("AS400Env", "", "")
   i = rdoEnv.CursorDriver       'default would be cursor library
    
   Set rdoConn = rdoEnv.OpenConnection("RCHASDCN", rdDriverNoPrompt)
   S = rdoConn.Version             'ODBC driver version
   b = rdoConn.Updatable          'TRUE/FALSE
    
   Set rdoPS = rdoConn.CreatePreparedStatement("Test", sSQL)
   'rdoPS.LockType = rdConcurReadOnly  'or rdConcurLock rdConcurValues
   With rdoConn.rdoPreparedStatements!Test
      i = .RowsetSize
      i = .rdoParameters(0).Type    'check the parameter type (1 is string)
      i = .rdoParameters(0).Direction '0- in, 1-out, 2 inout
      i = .rdoParameters(3).Type
      i = .rdoParameters(3).Direction 'check the direction RDO thinks it is

      '.rdoParameters(0).Direction = rdParamInput
      '.rdoParameters(1).Direction = rdParamInput
      'Output will give the SQL0470 null not allowed error
      '.rdoParameters(2).Direction = rdParamInputOutput
      '.rdoParameters(3).Direction = rdParamInputOutput

      '.rdoParameters(0) = lblParm1
      '.rdoParameters(1) = lblParm2
      '.rdoParameters(2) = " "
      '.rdoParameters(3) = " "
   
      'E2
      .rdoParameters(0).Direction = rdParamInputOutput
      .rdoParameters(1).Direction = rdParamInput
      .rdoParameters(2).Direction = rdParamInputOutput
      .rdoParameters(3).Direction = rdParamInput

      .rdoParameters(1) = lblParm1
      .rdoParameters(3) = lblParm2
      .rdoParameters(0) = " "
      .rdoParameters(2) = " "
   
      .Execute
      i = .Type    'rdQSelect   0  Select
                   'rdQAction   1  Action
                   'rdQProcedure   2  Procedural
    
      lblParm3 = .rdoParameters(2)
      lblParm4 = .rdoParameters(3)
    End With
    
    rdoPS.Close
    rdoConn.Close             'Close the ODBC connection
    rdoEnv.Close              'Can't close the default Env
    
End Sub


Private Sub mnuExit_Click()
   Unload Me
End Sub

Private Sub mnuSPRS_Click()
'Test of calling stored procedure with one input parameter.  Returns resultset.
   Dim rdoEnv As rdoEnvironment
   Dim rdoConn As rdoConnection
   Dim rdoPS As rdoPreparedStatement
   Dim rdoRS As rdoResultset
   Dim field1 As Variant   'stuff first fields data here
   Dim j As Integer
   Dim i As Integer
   Dim S As String
   Dim sSQL As String
   Dim b As Boolean
   Dim NumCalls As Integer 'number of times to run it.
    
   Dim sCRSDAVE As String
        
   lblParm1 = "in1"
   lblParm2 = "in2"
   sCRSDAVE = "Call CRSDAVE(?)"  'stored procedure call with one input parameter
                                  'returns result set
    
   Screen.ActiveForm.MousePointer = 11   'hourglass
   'Connect
   i = rdoEngine.rdoDefaultCursorDriver
   rdoEngine.rdoDefaultCursorDriver = 2   'ODBC
   Set rdoEnv = rdoCreateEnvironment("AS400Env", "", "")
   i = rdoEnv.CursorDriver
   Set rdoConn = rdoEnv.OpenConnection("RCHASDCN")
   S = rdoConn.Version             'ODBC driver version
   b = rdoConn.Updatable          'TRUE/FALSE
    
   'Prepare the statement only ONCE!
   Set rdoPS = rdoConn.CreatePreparedStatement("GetInfo", sCRSDAVE)
   i = rdoErrors.Count
   If i > 0 Then
       S = rdoErrors(0).Description
   End If
   rdoPS.LockType = rdConcurReadOnly
   i = rdoPS.RowsetSize
   'i = rdoPS.rdoParameters(0).Type    'check the parameter type
   rdoPS.rdoParameters(0).Direction = rdParamInput
   'rdoPS.rdoParameters(1).Direction = rdParamInput
    
   '*** Loop here if called multiple times
   For NumCalls = 1 To 2
      'Set the parameter
      rdoPS.rdoParameters(0) = "xzy"
      'rdoPS.rdoParameters(1) = 500
       
      'If calling the same statement multiple times, must only create the result set once
      'I used a wrapper around OpenResultset with an exception handler that checks if it
      'already exists.
      'Set rdoRS = rdoPS.OpenResultset(rdOpenForwardOnly)
      SetRS rdoRS, rdoPS
      i = rdoErrors.Count
      If i > 0 Then
          S = rdoErrors(0).Description
      End If
   
      'Parse the result set
      i = rdoPS.Type    'rdQSelect   0  Select
                        'rdQAction   1  Action
                        'rdQProcedure   2  Procedural
      i = rdoRS.rdoColumns.Count
      S = rdoRS.rdoColumns(0).Name
      j = 0
      Do While Not rdoRS.EOF
          j = j + 1
          field1 = rdoRS.rdoColumns(0).Value
          rdoRS.MoveNext
      Loop
       S = Str(j) & " rows fetched.  Last Value = " & Str(field1)
      MsgBox S
      
      rdoRS.MoreResults    'Check for multiple result sets / close cursor
      i = rdoErrors.Count
      If i > 0 Then
          S = rdoErrors(0).Description
          MsgBox "Error: " & S
      End If
   
   Next NumCalls '*** Loop here if calling multiple times
       
    rdoRS.Close
    rdoConn.Close             'Close the ODBC connection
    Screen.ActiveForm.MousePointer = 0   'default

    'rdoEnv.Close              'Can't close the default Env
End Sub


Private Sub mnuSPRS2_Click()
  'Calls a stored procedure that returns two result sets
  'Stored procedure result sets are forward only, readonly cursors

  Dim rdoEnv As rdoEnvironment
    Dim rdoConn As rdoConnection
    Dim rdoPS As rdoPreparedStatement
    Dim rdoRS As rdoResultset
    Dim field1 As Variant   'stuff first fields data here
    Dim j As Integer
    Dim i As Integer
    Dim S As String
    Dim sSQL As String
    Dim b As Boolean
    
    Dim sCRSDAVE As String
        
    lblParm1 = "in1"
    lblParm2 = "in2"
    sCRSDAVE = "CALL DDILLING.GUPTA2 (0)"
    
    i = rdoEngine.rdoDefaultCursorDriver
    rdoEngine.rdoDefaultCursorDriver = 2
    
    Set rdoEnv = rdoCreateEnvironment("AS400Env", "", "")
    i = rdoEnv.CursorDriver
    
    Set rdoConn = rdoEnv.OpenConnection("RCHASDCN")
    S = rdoConn.Version             'ODBC driver version
    b = rdoConn.Updatable          'TRUE/FALSE
    
    Set rdoPS = rdoConn.CreatePreparedStatement("GetInfo", sCRSDAVE)
    i = rdoErrors.Count
    If i > 0 Then
        S = rdoErrors(0).Description
    End If
    
    rdoPS.LockType = rdConcurReadOnly
    i = rdoPS.RowsetSize
    'i = rdoPS.rdoParameters(0).Type    'check the parameter type
    
    'rdoPS.rdoParameters(0).Direction = rdParamInput
    'rdoPS.rdoParameters(1).Direction = rdParamInput
    
    'rdoPS.rdoParameters(0) = 0
    'rdoPS.rdoParameters(1) = 500
    
    
    Set rdoRS = rdoPS.OpenResultset(rdOpenForwardOnly)
    i = rdoErrors.Count
    If i > 0 Then
        S = rdoErrors(0).Description
    End If

    i = rdoRS.rdoColumns.Count
    S = rdoRS.rdoColumns(0).Name
    j = 0
    Do While Not rdoRS.EOF
        j = j + 1
        field1 = rdoRS.rdoColumns(0).Value
        rdoRS.MoveNext
    Loop
    S = Str(j) & " rows fetched.  Last Value = " & Str(field1)
    MsgBox S
    
    'Get second result set
    If rdoRS.MoreResults = False Then
       S = "No further result sets to process"
       MsgBox S
    Else
      i = rdoErrors.Count
      If i > 0 Then
         S = rdoErrors(0).Description
         MsgBox "Error: " & S
      End If
      i = rdoRS.rdoColumns.Count
      S = rdoRS.rdoColumns(0).Name
      j = 0
      Do While Not rdoRS.EOF
        j = j + 1
        field1 = rdoRS.rdoColumns(0).Value
        rdoRS.MoveNext
      Loop
      S = Str(j) & " rows fetched.  Last Value = " & Str(field1)
      MsgBox S
   
      i = rdoPS.Type    'rdQSelect   0  Select
                     'rdQAction   1  Action
                     'rdQProcedure   2  Procedural
   End If
    
    
    rdoConn.Close             'Close the ODBC connection
    rdoEnv.Close              'Can't close the default Env

End Sub


